CON
	__MBOX_SIZE = 3
	__STACK_SIZE = 1
	Xmin = -35232152
	Xmax = 11744051
	Ymin = -20132660
	Ymax = 20132660
	Maxiter = 32
	Mpx = 79
	Mpy = 24
	Dx = 594635
	Dy = 1677721
	C4 = 67108864
VAR
  long __mbox[__MBOX_SIZE]
  long __objmem[18]
  long __stack[__STACK_SIZE]
  byte __cognum

PUB __cognew | id
  if (__cognum == 0)
    longfill(@__mbox, 0, __MBOX_SIZE)
    __mbox[0] := @__objmem
    __mbox[1] := @__stack
    id := cognew(@entry, @__mbox)
    __cognum := id + 1
  return id

PUB __cogstop
  if __cognum
    __lock  ' wait until everyone else is finished
    cogstop(__cognum~ - 1)
    __mbox[0] := 0
    __cognum := 0
PRI __lock
  repeat
    repeat until __mbox[0] == 0
    __mbox[0] := __cognum
  until __mbox[0] == __cognum

  repeat until __mbox[1] == 0
PRI __unlock
  __mbox[0] := 0

PRI __invoke(func, getresult) : r
  __mbox[1] := func - @entry
  if getresult
    repeat until __mbox[1] == 0
    r := __mbox[2]
  __unlock
  return r

PUB Start
  __lock
  return __invoke(@pasm_Start, 0)

DAT
	org	0
entry
	mov	mboxptr, par
	mov	arg1, #0
	rdlong	objptr, mboxptr
	wrlong	arg1, mboxptr
	add	mboxptr, #4
	rdlong	sp, mboxptr
	wrlong	arg1, mboxptr
waitloop
	rdlong	mboxcmd, mboxptr wz
 if_e	jmp	#waitloop
	add	mboxptr, #4
	shr	mboxcmd, #2
	jmp	mboxcmd
doreturn
	wrlong	result1, mboxptr
	sub	mboxptr, #4
	mov	arg1, #0
	wrlong	arg1, mboxptr
	jmp	#waitloop

pasm_Start
	movs	_Start_ret, #doreturn
_Start
	call	#_Simpleserial_cog___Cognew
	mov	arg1, imm_115200_
	call	#_Simpleserial_cog_Start
	mov	_Start_T, CNT
	mov	_Start_Cy, imm_4274834636_
	mov	_Start_Py, #25
L__0048
	mov	_Start_Cx, imm_4259735144_
	mov	_Start_Px, #80
L__0049
	mov	_Start_X, #0
	mov	_Start_Y, #0
	mov	_Start_Iter, #0
L__0044
	cmps	_Start_Iter, #32 wc,wz
 if_a	jmp	#L__0045
	mov	muldiva_, _Start_X
	mov	muldivb_, _Start_X
	call	#multiply_
	shl	muldivb_, #8
	mov	_Start__cse__0003, muldivb_
	mov	muldiva_, _Start_X
	mov	muldivb_, _Start_X
	call	#multiply_
	shr	muldiva_, #24
	or	_Start__cse__0003, muldiva_
	mov	_Start_X2, _Start__cse__0003
	mov	muldiva_, _Start_Y
	mov	muldivb_, _Start_Y
	call	#multiply_
	shl	muldivb_, #8
	mov	_Start__cse__0008, muldivb_
	mov	muldiva_, _Start_Y
	mov	muldivb_, _Start_Y
	call	#multiply_
	mov	_Start__cse__0010, muldiva_
	shr	_Start__cse__0010, #24
	or	_Start__cse__0008, _Start__cse__0010
	mov	_Start_Y2, _Start__cse__0008
	mov	Start_tmp001_, _Start_X2
	add	Start_tmp001_, _Start_Y2
	cmps	Start_tmp001_, imm_67108864_ wc,wz
 if_a	jmp	#L__0045
	mov	muldiva_, _Start_X
	mov	muldivb_, _Start_Y
	call	#multiply_
	shl	muldivb_, #9
	mov	_Start__cse__0013, muldivb_
	mov	muldiva_, _Start_X
	mov	muldivb_, _Start_Y
	call	#multiply_
	mov	_Start__cse__0015, muldiva_
	shr	_Start__cse__0015, #23
	or	_Start__cse__0013, _Start__cse__0015
	mov	_Start_Y, _Start__cse__0013
	add	_Start_Y, _Start_Cy
	sub	_Start_X2, _Start_Y2
	mov	_Start_X, _Start_X2
	add	_Start_X, _Start_Cx
	add	_Start_Iter, #1
	jmp	#L__0044
L__0045
	add	_Start_Cx, imm_594635_
	add	_Start_Iter, #32
	mov	arg1, _Start_Iter
	call	#_Simpleserial_cog_Tx
	djnz	_Start_Px, #L__0049
	add	_Start_Cy, imm_1677721_
	call	#_Simpleserial_cog_Nl
	djnz	_Start_Py, #L__0048
	mov	arg1, CNT
	sub	arg1, _Start_T
	call	#_Simpleserial_cog_Dec
	mov	arg1, ptr_L__0047_
	call	#_Simpleserial_cog_Str
	rdlong	arg1, #0
	add	arg1, CNT
	waitcnt	arg1, #0
	call	#_Simpleserial_cog___Cogstop
_Start_ret
	ret

pasm_Simpleserial_cog___Cognew
	movs	_Simpleserial_cog___Cognew_ret, #doreturn
_Simpleserial_cog___Cognew
	add	objptr, #68
	rdbyte	Simpleserial_cog___Cognew_tmp001_, objptr wz
	sub	objptr, #68
 if_ne	jmp	#L__0050
	mov	_Simpleserial_cog___Cognew__cse__0024, objptr
	mov	arg1, _Simpleserial_cog___Cognew__cse__0024
	mov	arg2, #0
	mov	arg3, #7
	call	#__system__Longfill
	add	objptr, #28
	mov	_Simpleserial_cog___Cognew__cse__0025, objptr
	sub	objptr, #28
	wrlong	_Simpleserial_cog___Cognew__cse__0025, objptr
	add	objptr, #64
	mov	_Simpleserial_cog___Cognew__cse__0026, objptr
	sub	objptr, #60
	wrlong	_Simpleserial_cog___Cognew__cse__0026, objptr
	sub	objptr, #4
	mov	arg2, ptr__Simpleserial_cog_dat__
	mov	arg3, objptr
	mov	arg1, #30
	call	#__system___Coginit
	mov	_Simpleserial_cog___Cognew_Id, result1
	mov	_Simpleserial_cog___Cognew__cse__0027, _Simpleserial_cog___Cognew_Id
	add	_Simpleserial_cog___Cognew__cse__0027, #1
	add	objptr, #68
	wrbyte	_Simpleserial_cog___Cognew__cse__0027, objptr
	sub	objptr, #68
L__0050
	mov	result1, _Simpleserial_cog___Cognew_Id
_Simpleserial_cog___Cognew_ret
	ret

pasm_Simpleserial_cog___Cogstop
	movs	_Simpleserial_cog___Cogstop_ret, #doreturn
_Simpleserial_cog___Cogstop
	add	objptr, #68
	rdbyte	Simpleserial_cog___Cogstop_tmp001_, objptr wz
	sub	objptr, #68
 if_e	jmp	#L__0051
	call	#_Simpleserial_cog___Lock
	add	objptr, #68
	rdbyte	_Simpleserial_cog___Cogstop__tmp__0001, objptr
	mov	Simpleserial_cog___Cogstop_tmp002_, #0
	wrbyte	Simpleserial_cog___Cogstop_tmp002_, objptr
	sub	objptr, #68
	mov	arg1, _Simpleserial_cog___Cogstop__tmp__0001
	sub	arg1, #1
	cogstop	arg1
	mov	result1, #0
	mov	Simpleserial_cog___Cogstop_tmp001_, #0
	wrlong	Simpleserial_cog___Cogstop_tmp001_, objptr
	mov	Simpleserial_cog___Cogstop_tmp001_, #0
	add	objptr, #68
	wrbyte	Simpleserial_cog___Cogstop_tmp001_, objptr
	sub	objptr, #68
L__0051
_Simpleserial_cog___Cogstop_ret
	ret

_Simpleserial_cog___Lock
L__0052
L__0055
	rdlong	_tmp001_, objptr wz
 if_ne	jmp	#L__0055
	add	objptr, #68
	rdbyte	_tmp001_, objptr
	sub	objptr, #68
	wrlong	_tmp001_, objptr
	add	objptr, #68
	rdbyte	_tmp002_, objptr
	sub	objptr, #68
	cmps	_tmp001_, _tmp002_ wz
 if_ne	jmp	#L__0052
L__0057
	add	objptr, #4
	rdlong	_tmp001_, objptr wz
	sub	objptr, #4
 if_ne	jmp	#L__0057
_Simpleserial_cog___Lock_ret
	ret

_Simpleserial_cog___Invoke
	mov	_var_R, #0
	sub	arg1, ptr__Simpleserial_cog_dat__
	add	objptr, #4
	wrlong	arg1, objptr
	sub	objptr, #4
	cmps	arg2, #0 wz
 if_e	jmp	#L__0059
L__0060
	add	objptr, #4
	rdlong	_tmp001_, objptr wz
	sub	objptr, #4
 if_ne	jmp	#L__0060
	add	objptr, #8
	rdlong	_var_R, objptr
	sub	objptr, #8
L__0059
	mov	_tmp001_, #0
	wrlong	_tmp001_, objptr
	mov	result1, _var_R
_Simpleserial_cog___Invoke_ret
	ret

pasm_Simpleserial_cog_Start
	movs	_Simpleserial_cog_Start_ret, #doreturn
_Simpleserial_cog_Start
	mov	_Simpleserial_cog_Start_Baudrate, arg1
	call	#_Simpleserial_cog___Lock
	add	objptr, #8
	wrlong	_Simpleserial_cog_Start_Baudrate, objptr
	sub	objptr, #8
	add	ptr__Simpleserial_cog_dat__, #100
	mov	arg1, ptr__Simpleserial_cog_dat__
	sub	ptr__Simpleserial_cog_dat__, #100
	mov	arg2, #1
	call	#_Simpleserial_cog___Invoke
_Simpleserial_cog_Start_ret
	ret

pasm_Simpleserial_cog_Tx
	movs	_Simpleserial_cog_Tx_ret, #doreturn
_Simpleserial_cog_Tx
	mov	_Simpleserial_cog_Tx_C, arg1
	call	#_Simpleserial_cog___Lock
	add	objptr, #8
	wrlong	_Simpleserial_cog_Tx_C, objptr
	sub	objptr, #8
	add	ptr__Simpleserial_cog_dat__, #128
	mov	arg1, ptr__Simpleserial_cog_dat__
	sub	ptr__Simpleserial_cog_dat__, #128
	mov	arg2, #0
	call	#_Simpleserial_cog___Invoke
_Simpleserial_cog_Tx_ret
	ret

pasm_Simpleserial_cog_Str
	movs	_Simpleserial_cog_Str_ret, #doreturn
_Simpleserial_cog_Str
	mov	_Simpleserial_cog_Str_S, arg1
	call	#_Simpleserial_cog___Lock
	add	objptr, #8
	wrlong	_Simpleserial_cog_Str_S, objptr
	sub	objptr, #8
	add	ptr__Simpleserial_cog_dat__, #196
	mov	arg1, ptr__Simpleserial_cog_dat__
	sub	ptr__Simpleserial_cog_dat__, #196
	mov	arg2, #0
	call	#_Simpleserial_cog___Invoke
_Simpleserial_cog_Str_ret
	ret

pasm_Simpleserial_cog_Num
	movs	_Simpleserial_cog_Num_ret, #doreturn
_Simpleserial_cog_Num
	mov	_Simpleserial_cog_Num_Val, arg1
	mov	_Simpleserial_cog_Num_Base, arg2
	mov	_Simpleserial_cog_Num_Signflag, arg3
	mov	_Simpleserial_cog_Num_Digitsneeded, arg4
	call	#_Simpleserial_cog___Lock
	add	objptr, #8
	wrlong	_Simpleserial_cog_Num_Val, objptr
	add	objptr, #4
	wrlong	_Simpleserial_cog_Num_Base, objptr
	add	objptr, #4
	wrlong	_Simpleserial_cog_Num_Signflag, objptr
	add	objptr, #4
	wrlong	_Simpleserial_cog_Num_Digitsneeded, objptr
	sub	objptr, #20
	add	ptr__Simpleserial_cog_dat__, #236
	mov	arg1, ptr__Simpleserial_cog_dat__
	sub	ptr__Simpleserial_cog_dat__, #236
	mov	arg2, #0
	call	#_Simpleserial_cog___Invoke
_Simpleserial_cog_Num_ret
	ret

pasm_Simpleserial_cog_Dec
	movs	_Simpleserial_cog_Dec_ret, #doreturn
_Simpleserial_cog_Dec
	mov	_Simpleserial_cog_Dec_Val, arg1
	call	#_Simpleserial_cog___Lock
	add	objptr, #8
	wrlong	_Simpleserial_cog_Dec_Val, objptr
	sub	objptr, #8
	mov	arg1, ptr__Simpleserial_cog_dat__
	add	arg1, imm_600_
	mov	arg2, #0
	call	#_Simpleserial_cog___Invoke
_Simpleserial_cog_Dec_ret
	ret

pasm_Simpleserial_cog_Decuns
	movs	_Simpleserial_cog_Decuns_ret, #doreturn
_Simpleserial_cog_Decuns
	mov	_Simpleserial_cog_Decuns_Val, arg1
	mov	_Simpleserial_cog_Decuns_Digits, arg2
	call	#_Simpleserial_cog___Lock
	add	objptr, #8
	wrlong	_Simpleserial_cog_Decuns_Val, objptr
	add	objptr, #4
	wrlong	_Simpleserial_cog_Decuns_Digits, objptr
	sub	objptr, #12
	mov	arg1, ptr__Simpleserial_cog_dat__
	add	arg1, imm_624_
	mov	arg2, #0
	call	#_Simpleserial_cog___Invoke
_Simpleserial_cog_Decuns_ret
	ret

pasm_Simpleserial_cog_Hex
	movs	_Simpleserial_cog_Hex_ret, #doreturn
_Simpleserial_cog_Hex
	mov	_Simpleserial_cog_Hex_Val, arg1
	mov	_Simpleserial_cog_Hex_Digits, arg2
	call	#_Simpleserial_cog___Lock
	add	objptr, #8
	wrlong	_Simpleserial_cog_Hex_Val, objptr
	add	objptr, #4
	wrlong	_Simpleserial_cog_Hex_Digits, objptr
	sub	objptr, #12
	mov	arg1, ptr__Simpleserial_cog_dat__
	add	arg1, imm_648_
	mov	arg2, #0
	call	#_Simpleserial_cog___Invoke
_Simpleserial_cog_Hex_ret
	ret

pasm_Simpleserial_cog_Nl
	movs	_Simpleserial_cog_Nl_ret, #doreturn
_Simpleserial_cog_Nl
	call	#_Simpleserial_cog___Lock
	mov	arg1, ptr__Simpleserial_cog_dat__
	add	arg1, imm_672_
	mov	arg2, #0
	call	#_Simpleserial_cog___Invoke
_Simpleserial_cog_Nl_ret
	ret

multiply_
	mov	itmp2_, muldiva_
	xor	itmp2_, muldivb_
	abs	muldiva_, muldiva_
	abs	muldivb_, muldivb_
	mov	result1, #0
	mov	itmp1_, #32
	shr	muldiva_, #1 wc
mul_lp_
 if_c	add	result1, muldivb_ wc
	rcr	result1, #1 wc
	rcr	muldiva_, #1 wc
	djnz	itmp1_, #mul_lp_
	shr	itmp2_, #31 wz
 if_nz	neg	result1, result1
 if_nz	neg	muldiva_, muldiva_ wz
 if_nz	sub	result1, #1
	mov	muldivb_, result1
multiply__ret
	ret

__system__Longfill
	cmps	arg3, #0 wz
 if_e	jmp	#L__90018
L__90019
	wrlong	arg2, arg1
	add	arg1, #4
	djnz	arg3, #L__90019
L__90018
__system__Longfill_ret
	ret

__system___Coginit
	and	arg3, imm_65532_
	shl	arg3, #16
	and	arg2, imm_65532_
	shl	arg2, #2
	or	arg3, arg2
	and	arg1, #15
	or	arg3, arg1
	coginit	arg3 wr
	mov	result1, arg3
__system___Coginit_ret
	ret

imm_115200_
	long	115200
imm_1677721_
	long	1677721
imm_4259735144_
	long	-35232152
imm_4274834636_
	long	-20132660
imm_594635_
	long	594635
imm_600_
	long	600
imm_624_
	long	624
imm_648_
	long	648
imm_65532_
	long	65532
imm_67108864_
	long	67108864
imm_672_
	long	672
itmp1_
	long	0
itmp2_
	long	0
mboxcmd
	long	0
mboxptr
	long	0
objptr
	long	0
ptr_L__0047_
	long	@@@L__0047
ptr__Simpleserial_cog_dat__
	long	@@@_Simpleserial_cog_dat_
result1
	long	0
sp
	long	0
COG_BSS_START
	fit	496

L__0047
	byte	" ticks"
	byte	13
	byte	10
	byte	0
	long
_Simpleserial_cog_dat_
	long	$a0bd8bf0
	long	$a0fdd200
	long	$08bd8cc5
	long	$083dd2c5
	long	$80fd8a04
	long	$08bd90c5
	long	$083dd2c5
	long	$0abd88c5
	long	$5c680007
	long	$80fd8a04
	long	$08bdd2c5
	long	$80fd8a04
	long	$08bdd4c5
	long	$80fd8a04
	long	$08bdd6c5
	long	$80fd8a04
	long	$08bdd8c5
	long	$84fd8a0c
	long	$28fd8802
	long	$5c3c00c4
	long	$083d8ec5
	long	$84fd8a04
	long	$a0fdd200
	long	$083dd2c5
	long	$5c7c0007
	long	$50fc3e14
	long	$08fdda00
	long	$a0bddce9
	long	$5cfd7eae
	long	$083ddcc6
	long	$a0fd8e01
	long	$5c7c0000
	long	$50fc6014
	long	$a0bdd0c1
	long	$68bfe8c1
	long	$68bfecc1
	long	$68fdd300
	long	$2cfdd201
	long	$a0bdcce9
	long	$a0bdcbf1
	long	$a0fdce0a
	long	$08bd9ac6
	long	$80bdcacd
	long	$a0bdd2e5
	long	$f8fdd200
	long	$29fdcc01
	long	$70bfe8e8
	long	$e4fdce29
	long	$5c7c0000
	long	$50fc7414
	long	$a0bdc8e9
	long	$a0bd98e4
	long	$80fdc801
	long	$02bdc6cc
	long	$5c68003a
	long	$a0bdd2e3
	long	$5cfc6021
	long	$5c7c0033
	long	$5c7c0000
	long	$50fd2a14
	long	$a0bdaae9
	long	$a0bd9cea
	long	$a2bda8eb
	long	$a0bda0ec
	long	$5c680044
	long	$c37daa00
	long	$a0f1a82d
	long	$a4b1aad5
	long	$c37da020
	long	$a0c5a020
	long	$a0fda200
	long	$c37daa00
	long	$5c4c0064
	long	$a0bdacd5
	long	$60fdac01
	long	$a0bda6d6
	long	$28fdaa01
	long	$a0bdaed5
	long	$a0bda4d7
	long	$a0bddad2
	long	$a0bddcce
	long	$5cfd7eae
	long	$a0bdb0ed
	long	$a0bdb2d8
	long	$2cfdb201
	long	$a0bdb4d3
	long	$80bdb4d9
	long	$a0bd9eda
	long	$a0bddad2
	long	$a0bddcce
	long	$5cfd7eae
	long	$a0bdb6ee
	long	$a0bdb8db
	long	$2cfdb801
	long	$a0bdaadc
	long	$c33d9ece
	long	$80cdaa01
	long	$848d9ece
	long	$a08dbacf
	long	$5c7c006e
	long	$a0bddad5
	long	$a0bddcce
	long	$5cfd7eae
	long	$a0bdbced
	long	$a0bd9ede
	long	$a0bddad5
	long	$a0bddcce
	long	$5cfd7eae
	long	$a0bdbeee
	long	$a0bdaadf
	long	$c37d9e00
	long	$5c700074
	long	$c37d9e09
	long	$80f99e30
	long	$a0b9c0cf
	long	$5c780079
	long	$84fd9e0a
	long	$a0bdc2cf
	long	$a0bdc4e1
	long	$80fdc441
	long	$a0bd9ee2
	long	$a0bd96d1
	long	$80fda201
	long	$80fd8c04
	long	$a0bd94c6
	long	$84fd8c04
	long	$80bd94cb
	long	$003d9eca
	long	$84fda001
	long	$c27daa00
	long	$5c540085
	long	$c37da000
	long	$5c780087
	long	$c37da220
	long	$5c700047
	long	$c37da801
	long	$5c78008b
	long	$a0bdd2d4
	long	$5cfc6021
	long	$c37da200
	long	$5c780095
	long	$84fda201
	long	$80fd8c04
	long	$a0bd92c6
	long	$84fd8c04
	long	$80bd92d1
	long	$00bdd2c9
	long	$5cfc6021
	long	$5c7c008b
	long	$5c7c0000
	long	$50fd3614
	long	$a0fdd40a
	long	$a0fdd601
	long	$a0fdd800
	long	$5cfd2a3c
	long	$5c7c0000
	long	$50fd4214
	long	$a0bdd8ea
	long	$a0fdd40a
	long	$a0fdd600
	long	$5cfd2a3c
	long	$5c7c0000
	long	$50fd4e14
	long	$a0bdd8ea
	long	$a0fdd410
	long	$a0fdd600
	long	$5cfd2a3c
	long	$5c7c0000
	long	$50fd5a14
	long	$a0fdd20d
	long	$5cfc6021
	long	$a0fdd20a
	long	$5cfc6021
	long	$5c7c0000
	long	$a9bddaed
	long	$70fd8603
	long	$abbddcee
	long	$6cf18602
	long	$a0fd8400
	long	$a0fd8020
	long	$2bfddc01
	long	$30fd8401
	long	$e4d580b4
	long	$e1bddac2
	long	$34fddc01
	long	$28fd8401
	long	$e4fd80b7
	long	$617d8601
	long	$b0bddaed
	long	$617d8602
	long	$b0bddcee
	long	$5c7c0000
	long	$00000000
	long	$40000000
	long	$00000000
	long	$00000000
	long	$00000000
	long	$00000000
	long	$00000000
	long	$00000000
	long	$00000000
	org	COG_BSS_START
Simpleserial_cog___Cognew_tmp001_
	res	1
Simpleserial_cog___Cogstop_tmp001_
	res	1
Simpleserial_cog___Cogstop_tmp002_
	res	1
Start_tmp001_
	res	1
_Simpleserial_cog_Dec_Val
	res	1
_Simpleserial_cog_Decuns_Digits
	res	1
_Simpleserial_cog_Decuns_Val
	res	1
_Simpleserial_cog_Hex_Digits
	res	1
_Simpleserial_cog_Hex_Val
	res	1
_Simpleserial_cog_Num_Base
	res	1
_Simpleserial_cog_Num_Digitsneeded
	res	1
_Simpleserial_cog_Num_Signflag
	res	1
_Simpleserial_cog_Num_Val
	res	1
_Simpleserial_cog_Start_Baudrate
	res	1
_Simpleserial_cog_Str_S
	res	1
_Simpleserial_cog_Tx_C
	res	1
_Simpleserial_cog___Cognew_Id
	res	1
_Simpleserial_cog___Cognew__cse__0024
	res	1
_Simpleserial_cog___Cognew__cse__0025
	res	1
_Simpleserial_cog___Cognew__cse__0026
	res	1
_Simpleserial_cog___Cognew__cse__0027
	res	1
_Simpleserial_cog___Cogstop__tmp__0001
	res	1
_Start_Cx
	res	1
_Start_Cy
	res	1
_Start_Iter
	res	1
_Start_Px
	res	1
_Start_Py
	res	1
_Start_T
	res	1
_Start_X
	res	1
_Start_X2
	res	1
_Start_Y
	res	1
_Start_Y2
	res	1
_Start__cse__0003
	res	1
_Start__cse__0008
	res	1
_Start__cse__0010
	res	1
_Start__cse__0013
	res	1
_Start__cse__0015
	res	1
_tmp001_
	res	1
_tmp002_
	res	1
_var_R
	res	1
arg1
	res	1
arg2
	res	1
arg3
	res	1
arg4
	res	1
muldiva_
	res	1
muldivb_
	res	1
	fit	496
